#ifndef _LUMA_FS_H
#define _LUMA_FS_H

#include"../std.h"

// Paths are not handled as strings, but rather as packed arrays of strings
// This way there is no need for escaping, separators, etc.

typedef enum {
	LUMA_FS_COMMAND_READ, LUMA_FS_COMMAND_INFO, LUMA_FS_COMMAND_TRAVERSE
} LumaFSCommandOp;

typedef union {
	uint8_t op;
	struct {
		uint8_t op;
		uint64_t offset;
		uint32_t bytes;
		uint8_t path[]; //Packed array of Str16
	} read;
	struct {
		uint8_t op;
		uint64_t fileSize;
		uint8_t path[]; //Packed array of Str16
	} info;
	struct {
		uint8_t op;
		uint8_t path[]; // Packed array of Str16
	} traverse;
} LumaFSCommand;

#define LUMA_FS_DIR_ENTRY_ISDIR 2
#define LUMA_FS_DIR_ENTRY_LAST 1
typedef struct {
	uint16_t type;
	Str16 name;
} LumaFSDirectoryEntry;

#endif