#ifndef _LUMA_KBD_H
#define _LUMA_KBD_H

enum LumaKbdScancode {
	LK_INVALID,
	LK_0,
	LK_1,
	LK_2,
	LK_3,
	LK_4,
	LK_5,
	LK_6,
	LK_7,
	LK_8,
	LK_9,
	LK_F1,
	LK_F2,
	LK_F3,
	LK_F4,
	LK_F5,
	LK_F6,
	LK_F7,
	LK_F8,
	LK_F9,
	LK_F10,
	LK_F11,
	LK_F12,
	LK_PAUSE,
	LK_LEFT_ALT,
	LK_RIGHT_ALT,
	LK_LEFT_SHIFT,
	LK_RIGHT_SHIFT,
	LK_LEFT_CTRL,
	LK_RIGHT_CTRL,
	LK_LEFT_SYS,
	LK_RIGHT_SYS,
	LK_BACKSPACE,
	LK_A,
	LK_B,
	LK_C,
	LK_D,
	LK_E,
	LK_F,
	LK_G,
	LK_H,
	LK_I,
	LK_J,
	LK_K,
	LK_L,
	LK_M,
	LK_N,
	LK_O,
	LK_P,
	LK_Q,
	LK_R,
	LK_S,
	LK_T,
	LK_U,
	LK_V,
	LK_W,
	LK_X,
	LK_Y,
	LK_Z,
	LK_SPACE,
	LK_SLASH,
	LK_COMMA,
	LK_PERIOD,
	LK_SOLIDUS,
	LK_SEMICOLON,
	LK_SQUOTE,
	LK_DQUOTE,
	LK_S_BRACKET_L,
	LK_S_BRACKET_R,
	LK_R_BRACKET_L,
	LK_R_BRACKET_R,
	LK_DASH,
	LK_EQUALS,
	LK_ENTER,
	LK_ESCAPE,
	LK_UP,
	LK_DOWN,
	LK_LEFT,
	LK_RIGHT,
};

#define KEYEV_FLAG_FREE 0
#define KEYEV_FLAG_PRESS 1
#define KEYEV_FLAG_RELEASE 2
struct LumaKbdEvent {
	uint8_t scancode;
	uint8_t flag;
} __attribute__((packed));

#define KEYBUF_SIZE 4096
#define KEYBUF_MAX (4096 / sizeof(struct LumaKbdEvent))

#endif