#ifndef _LUMA_VBE_VBE_H
#define _LUMA_VBE_VBE_H

#include<stdint.h>

typedef enum {
	LUMA_VID_COMMAND_END = 0, LUMA_VID_COMMAND_CLEAR = 1, LUMA_VID_COMMAND_RECT = 2, LUMA_VID_COMMAND_IMAGE = 3, LUMA_VID_COMMAND_IMAGE_NEW = 4, LUMA_VID_COMMAND_SET_COLOR_FLAT = 5,
	LUMA_VID_COMMAND_SET_COLOR_GRAD = 6, LUMA_VID_COMMAND_IMAGE_DEL = 7, LUMA_VID_COMMAND_TEXT = 8, LUMA_VID_COMMAND_NEW_COLOR_FLAT = 9, LUMA_VID_COMMAND_NEW_COLOR_GRAD = 10, LUMA_VID_COMMAND_IMAGE_WRITE = 11,
} LumaVidCommandOp;

typedef enum {
	LUMA_VID_IMAGE_FORMAT_RAW = 0, LUMA_VID_IMAGE_FORMAT_R8G8B8 = 1, LUMA_VID_IMAGE_FORMAT_BLALPHA = 2
} LumaVidImageDescriptionFormat;

typedef enum {
	LUMA_VID_ALIGN_TOP_LEFT = 0,
	LUMA_VID_ALIGN_TOP_RIGHT = 1,
	LUMA_VID_ALIGN_BOTTOM_LEFT = 2,
	LUMA_VID_ALIGN_BOTTOM_RIGHT = 3,
} LumaVidAlign;

typedef union {
	uint8_t op;
	struct {
		uint8_t op;
	} __attribute__((packed)) clear;
	struct {
		uint8_t op;
		uint16_t y2;
		uint16_t x2;
		uint16_t y1;
		uint16_t x1;
	} __attribute__((packed)) rect;
	struct {
		uint8_t op;
		uint16_t y;
		uint16_t x;
		uint16_t subY;
		uint16_t subX;
		uint16_t width;
		uint16_t height;
		uint32_t name;
	} __attribute__((packed)) image;
	struct {
		uint8_t op;
		uint32_t name;
		uint16_t width;
		uint16_t height;
		uint8_t format;
	} __attribute__((packed)) imageNew;
	struct {
		uint8_t op;
		uint8_t r;
		uint8_t g;
		uint8_t b;
	} __attribute__((packed)) colorFlat;
	struct {
		uint8_t op;
		uint8_t r1;
		uint8_t r2;
		uint8_t g1;
		uint8_t g2;
		uint8_t b1;
		uint8_t b2;
	} __attribute__((packed)) colorGrad;
	struct {
		uint8_t op;
		uint32_t name;
	} __attribute__((packed)) imageDel;
	struct {
		uint8_t op;
		uint16_t y;
		uint16_t x;
		uint16_t len;
		uint16_t wall;
		uint8_t data[];
	} __attribute__((packed)) text;
	struct {
		uint8_t op;
		uint32_t name;
		uint16_t y;
		uint16_t x;
		uint16_t len;
		uint8_t data[];
	} __attribute__((packed)) imageWrite;
} __attribute__((packed)) LumaVidCommand;

#endif