#pragma once

#include<stdint.h>
#include<stddef.h>

typedef uint32_t LumaWMObjID;
typedef uint16_t LumaWMObjKind;
typedef uint32_t LumaWMObjProperty;

#define LUMA_WM_KIND_CONTAINER 1
#define LUMA_WM_KIND_LABEL 2

#define LUMA_WM_PROP_TEXT 1
#define LUMA_WM_PROP_CONTAINER_ORDER 2

typedef struct {
	void *area;
} LumaWMClient;

typedef struct {
	uint16_t cmd;
	uint16_t sz;
} LumaWMCmdHeader;

typedef struct __attribute__((packed)) {
	LumaWMObjID id;
	LumaWMObjKind kind;
} LumaWMObjDesc;

typedef struct __attribute__((packed)) {
	LumaWMCmdHeader header;
	
	LumaWMObjDesc descs[];
} LumaWMRegisterObjects;

typedef struct __attribute__((packed)) {
	LumaWMCmdHeader header;
	
	LumaWMObjID object;
	
	LumaWMObjProperty property;
	
	uint8_t data[];
} LumaWMSetProperty;

int luma_wm_client(LumaWMClient*);
int luma_wm_window_create(LumaWMClient*);
int luma_wm_register_objects(LumaWMClient*, LumaWMObjDesc*, size_t count);
int luma_wm_set_property(LumaWMClient*, LumaWMObjID object, LumaWMObjProperty prop, void *data, size_t length);
