#!/usr/bin/env python3

import PIL.Image, struct, bitstring, xml.etree.ElementTree

o = open("../chars.bin", "wb")

xml = xml.etree.ElementTree.parse("l.fnt")
img = PIL.Image.open("l_0.tga")

for ch in xml.getroot().find("chars").findall("char"):
	assert int(ch.attrib["width"]) < 16 or int(ch.attrib["height"]) < 16, "Image too big: " + ch.attrib["id"]
	o.write(struct.pack("BBB",
		int(ch.attrib["id"]),
		(int(ch.attrib["width"]) << 4) | int(ch.attrib["height"]),
		(int(ch.attrib["yoffset"]) << 4) | int(ch.attrib["xadvance"])
	))
	a = []
	for y in range(0, int(ch.attrib["height"])):
		for x in range(0, int(ch.attrib["width"])):
			a += [img.getpixel((int(ch.attrib["x"]) + x, int(ch.attrib["y"]) + y)) // 255]
	a = [a[i * 8 : (i + 1) * 8] for i in range((len(a) + 7) // 8)]
	while len(a[-1]) < 8:
		a[-1] += [0]
	for l in a: l.reverse()
	a = sum(a, [])
	bitstring.BitArray(a).tofile(o)

o.close()