#ifndef _CANAL_H
#define _CANAL_H

#include<stdint.h>

#define LINK_FLAG_ACCEPTED 1

#define LINK_FLAG_G2H 2
#define LINK_FLAG_H2G 4

struct Process;
struct Link;

typedef struct Canal {
	uint64_t name;
	struct Process *hostProcess;
	struct Canal *ownedNext;
	struct Link *links;
} __attribute__((packed)) Canal;

typedef struct Link {
	uint32_t canalId;
	uint32_t hostVirtAddr;
	struct Process *guestProcess;
	uint32_t guestVirtAddr;
	uint32_t metaG2H;
	uint32_t metaH2G;
	uint8_t flags;
	struct Link *nextInCanal;
	struct Link *nextGuestLink;
} __attribute__((packed)) Link;

uint32_t canal_create(uint64_t name, uint16_t hostProcessId);
uint32_t link_create(uint64_t canal, uint16_t guestProcessId, uint32_t areaSize);
uint32_t canal_accept(uint16_t hostProcessId, uint32_t canalId);
void link_send_signal_from(uint16_t processId, uint32_t processAreaAddr, uint32_t meta);
uint32_t link_get_oldest_signal_to(uint16_t processId);
uint32_t is_signal_awaiting_to_concerning_link(uint16_t processId, uint32_t area, uint32_t *metaOut, uint32_t *canalId);

uint32_t signal_accept(struct Process *p, Link *l, uint32_t *meta);

#endif
