#ifndef _PROCESS_H
#define _PROCESS_H

#include<stdint.h>

struct Canal;
struct Link;

typedef struct __attribute__((packed)) {
	uint32_t eax;    //0
	uint32_t ebx;    //4
	uint32_t ecx;    //8
	uint32_t edx;    //12
	uint32_t esi;    //16
	uint32_t edi;    //20
	uint32_t ebp;    //24
	uint32_t esp;    //28
	uint32_t eip;    //32
	uint32_t eflags; //36
	uint32_t cs;     //40
	uint32_t cr3;    //44
} Context;

#define WAIT_TYPE_NONE 0
#define WAIT_TYPE_SIGNAL 1
#define WAIT_TYPE_TIME 2
#define WAIT_TYPE_IRQ 3
#define WAIT_TYPE_MINOR 4

typedef struct __attribute__((packed)) Process {
	uint16_t id;
	Context ctx;
	uint8_t waitType;
	uint32_t waitValue;
	uint32_t irqWaiting;
	uint8_t minipriority;
	struct Process *next;
	uint16_t ownerId;
	uint8_t eventsRequest;
	uint8_t eventsSignal;
	uint8_t eventsClosed;
	struct Canal *ownedCanal;
	struct Link *guestLinks;
} Process;

#endif
